package com.covas.Resources;

import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.HashSet;


import javax.inject.Inject;
import javax.ws.rs.CookieParam;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.NewCookie;
import javax.ws.rs.core.Response;

import com.covas.Classes.Hash;
import com.covas.Entity.UsersEntity;
import com.covas.Json.Message;

import io.smallrye.jwt.auth.principal.JWTParser;
import io.smallrye.jwt.auth.principal.ParseException;
import io.smallrye.jwt.build.Jwt;

import org.eclipse.microprofile.jwt.JsonWebToken;
import org.jboss.resteasy.annotations.jaxrs.HeaderParam;
import org.postgresql.shaded.com.ongres.scram.common.bouncycastle.base64.Base64;

@Path("/api")
public class TokenRessource {
    @Inject
    JsonWebToken jwt;

   
    @Inject JWTParser parser;

    @GET
    @Produces(MediaType.APPLICATION_JSON)
    @Path("token")
    public Response getUserName(@HeaderParam("Authorization") String auth, @CookieParam("jwt") String jwtCookie) {
        String name = "anonymous";
        String password = "";
        
        if (jwtCookie == null) {
            String[] hash = new String(Base64.decode(auth.split(" ")[1]), StandardCharsets.UTF_8).split(":");
            name = hash[0];
            password = Hash.encryptSHA512(hash[1]);

            UsersEntity users = UsersEntity.findByPseudo(name);
            if(users != null){

                if(password.equals(users.password)){
                    // Create a JWT token signed using the 'HS256' algorithm
                    String newJwtCookie = Jwt.issuer("https://example.com/issuer").upn(name).groups(new HashSet<>(Arrays.asList(users.roles))).sign();
                    // or create a JWT token encrypted using the 'A256KW' algorithm
                    // Jwt.upn("alice").encryptWithSecret(secret);
                    return Response.status(Response.Status.CREATED).entity(new Message(name, "Token is generated")).cookie(new NewCookie("jwt", newJwtCookie)).build();
                } else {
                    return Response.status(Response.Status.FORBIDDEN).entity(new Message(name, false, "Password is incorrect")).build();
                }

                 
            }
            return Response.status(Response.Status.NOT_FOUND).entity(new Message(name, false, "User not found")).build();
          
      } else {
          // All mp.jwt and smallrye.jwt properties are still effective, only the verification key is customized.
          try {
                jwt = parser.parse(jwtCookie);
          } 
          catch(ParseException p){
              return Response.status(Response.Status.NOT_ACCEPTABLE).entity(new Message(name, false, p.getMessage())).build();
          }
          // or jwt = parser.decrypt(jwtCookie, secret);
          return Response.status(Response.Status.OK).entity(new Message(jwt.getName(),"Token is still valid")).build();
        }
    }
}
